﻿using System;

class Program {
	static object m_retObject_argString(string s) {
		return new object();
	}

	static string m_retString_argString(string s) {
		return s;
	}

	static string m_retString_argObject(object o) {
		return o.ToString();
	}

	static object m_retObject_argObject(object o) {
		return o;
	}

	delegate object RetObjectArgStringDelegate(string str);

	delegate object AnotherRetObjectArgStringDelegate(string str);

	delegate string RetStringArgStringDelegate(string str);

	static void Main(string[] args) {
		RetObjectArgStringDelegate rObj = m_retObject_argString;
		object o = rObj("Hello");

		rObj = m_retString_argString;
		o = rObj("Hello");

		rObj = m_retObject_argObject;
		o = rObj("Hello");

		rObj = m_retString_argObject;
		o = rObj("Hello");
		
		RetStringArgStringDelegate rStr = m_retString_argObject;
		string s = rStr("Hello");

		// Error: 'object Program.m_retObject_argString(string)' has the wrong return type
		// rStr = m_retObject_argString;
		s = rStr("Hello");

		AnotherRetObjectArgStringDelegate rObjAnother = m_retString_argString;
		// Error: Cannot implicitly convert type 'RetObjectArgStringDelegate' to 'AnotherRetObjectArgStringDelegate'
		// rObjAnother = rObj;
		// Error: Cannot convert type 'RetObjectArgStringDelegate' to 'AnotherRetObjectArgStringDelegate'
		// rObjAnother = (AnotherRetObjectArgStringDelegate) rObj;

		TestGenericDelegates();
	}

	delegate R InvariantDelegate<R, A>(A arg);

	delegate R AnotherInvariantDelegate<R, A>(A arg);

	delegate R VariantDelegate<out R, in A>(A arg);

	delegate R AnotherVariantDelegate<out R, in A>(A arg);

	static void TestGenericDelegates() {
		#region Part 1
		// Part 1: variance against methods
		//
		InvariantDelegate<object, string> invRetObjArgStr = m_retObject_argString;
		object o = invRetObjArgStr("Hello");

		invRetObjArgStr = m_retString_argString;
		o = invRetObjArgStr("Hello");

		invRetObjArgStr = m_retObject_argObject;
		o = invRetObjArgStr("Hello");

		// Error: Cannot implicitly convert type 'Program.AnotherInvariantDelegate<object, string>' to 'Program.InvariantDelegate<object, string>'
		// invRetObjArgStr = new AnotherInvariantDelegate<object, string>(m_retObject_argString);

		// Error: Cannot convert type 'Program.AnotherInvariantDelegate<object, string>' to 'Program.InvariantDelegate<object, string>'
		// invRetObjArgStr = (InvariantDelegate<object, string>) (new AnotherInvariantDelegate<object, string>(m_retObject_argString);)

		InvariantDelegate<object, object> invRetObjArgObj;
		// Would be wrong - would allow passing object to string method => Error: Cannot implicitly convert
		// invRetObjArgObj = (InvariantDelegate<object, object>) invRetObjArgStr;

		invRetObjArgObj = m_retObject_argObject;
		// Would be OK - would allow passing string to object method
		// Error: Cannot implicitly convert type 'Program.InvariantDelegate<object, object>' to 'Program.InvariantDelegate<object, string>'
		// invRetObjArgStr = invRetObjArgObj;
		#endregion
		//
		// Part 2: variant generic delegates
		//

		VariantDelegate<object, object> variRetObjArgObj;
		variRetObjArgObj = m_retObject_argObject;

		VariantDelegate<object, string> variRetObjArgStr = variRetObjArgObj;
		o = variRetObjArgStr("Hello");

		// Error: Cannot implicitly convert type 'Program.VariantDelegate<object,string>' to 'Program.VariantDelegate<object,object>'. 
		//		  An explicit conversion exists (are you missing a cast?)
		// variRetObjArgObj = variRetObjArgStr;

		variRetObjArgObj = (VariantDelegate<object, object>) variRetObjArgStr;

		variRetObjArgStr = m_retObject_argString;
		try {
			variRetObjArgObj = (VariantDelegate<object, object>) variRetObjArgStr;
			o = variRetObjArgObj(new object());
		} catch (Exception ex) {
			Console.WriteLine($"RUNTIME ERROR: {ex}");
		}

		//

		variRetObjArgStr = m_retObject_argString;
		AnotherVariantDelegate<object, string> retObjArgStrAnother;
		// Error: Cannot implicitly convert type 'Program.VariantDelegate<object,string>' to 'Program.AnotherVariantDelegate<object,string>'
		// retObjArgStrAnother = variRetObjArgStr;
		// Error: Cannot convert type 'Program.VariantDelegate<object,string>' to 'Program.AnotherVariantDelegate<object,string>'
		// retObjArgStrAnother = (AnotherVariantDelegate<object, string>) variRetObjArgStr;
	}
}
